Index: setup.py
===================================================================
--- setup.py	(revision 16818)
+++ setup.py	(working copy)
@@ -10,7 +10,7 @@
 from setuptools import setup
 
 setup(name='TracFullBlogPlugin',
-      version='0.1.6.2',
+      version='0.1.6.3',
       packages=['tracfullblog'],
       author='CodeResort.com = BV Network AS',
       author_email='simon-code@bvnetwork.no',
Index: tracfullblog/templates/fullblog_edit.html
===================================================================
--- tracfullblog/templates/fullblog_edit.html	(revision 16818)
+++ tracfullblog/templates/fullblog_edit.html	(working copy)
@@ -100,7 +100,7 @@
                 <input id="blog-author" type="text"
                       name="author" size="40"
                       value="${(defined('blog_edit') and blog_edit.author)
-                               or (req.session.get('name') or req.authname)}" />
+                               or get_reporter_id(req)}" />
               </div>
               <div class="field">
                 <label for="blog-categories">Categories (space separated):</label><br />
Index: tracfullblog/templates/fullblog_macro_monthlist.html
===================================================================
--- tracfullblog/templates/fullblog_macro_monthlist.html	(revision 16818)
+++ tracfullblog/templates/fullblog_macro_monthlist.html	(working copy)
@@ -8,9 +8,9 @@
         <li py:for="name, version, time, author, title, body, categories in posts">
           <a href="${req.href.blog(name)}">${title}</a>
           <span class="metainfo" py:if="not defined('show_meta') and True or show_meta">
-            &nbsp;-- Posted on ${format_datetime(time, '%Y-%m-%d %H:%M')}
+            &nbsp;-- Posted on ${pretty_dateinfo and pretty_dateinfo(time) or format_datetime(time)}
             <py:if test="not blog_personal_blog">
-              : author <a href="${req.href.blog('author', author)}">${author}</a>
+              : author <a href="${req.href.blog('author', author)}">${authorinfo(author)}</a>
             </py:if>
             <py:if test="categories">
               : categories
Index: tracfullblog/templates/fullblog_macro_post.html
===================================================================
--- tracfullblog/templates/fullblog_macro_post.html	(revision 16818)
+++ tracfullblog/templates/fullblog_macro_post.html	(working copy)
@@ -12,13 +12,13 @@
         <p py:if="do_shorten"><a href="${href.blog(post.name)}">(Read more)</a></p>
     </div>
     <ul class="metainfo" py:if="not defined('show_meta') and True or show_meta">
-      <li class="metadates">Posted: ${format_datetime(post.publish_time, '%Y-%m-%d %H:%M')}
+      <li class="metadates">Posted: ${pretty_dateinfo and pretty_dateinfo(post.publish_time) or format_datetime(post.publish_time)}
         <span class="metaupdated" py:if="len(post.versions) > 1">
-          (Updated: ${format_datetime(post.version_time, '%Y-%m-%d %H:%M')})
+          (Updated: ${pretty_dateinfo and pretty_dateinfo(post.version_time) or format_datetime(post.version_time)})
         </span>
       </li>
       <li class="metaauthor" py:if="not blog_personal_blog">Author:
-        <a href="${req.href.blog('author', post.author)}">${post.author}</a> </li>
+        <a href="${req.href.blog('author', post.author)}">${authorinfo(post.author)}</a> </li>
       <li class="metacategories">Categories:
         <py:for each="cat in post.category_list">
           <a href="${req.href.blog('category', cat)}">${cat}</a>
Index: tracfullblog/templates/fullblog_view.html
===================================================================
--- tracfullblog/templates/fullblog_view.html	(revision 16818)
+++ tracfullblog/templates/fullblog_view.html	(working copy)
@@ -88,8 +88,8 @@
                 <div class="comment-info">
                     <a href="${req.href.blog(comment.post_name)}#comment-${to_unicode(comment.number)}">
                       ${comment.number}.</a>
-                    ${format_author(comment.author)} --
-                    ${format_datetime(comment.time, '%Y-%m-%d %H:%M')}</div>
+                    ${authorinfo(comment.author)} --
+                    ${pretty_dateinfo and pretty_dateinfo(comment.time) or format_datetime(comment.time)}</div>
                 <div class="comment-body">${wiki_to_html(context, comment.comment)}</div>
               </div>
             </py:if>
@@ -109,8 +109,8 @@
                         <a py:if="req.chrome.warnings" href="#warning">(Warnings)</a>
                       </legend>
                       <div class="comment-info">
-                        ${format_author(blog_comment.author)} --
-                        ${format_datetime(blog_comment.time, '%Y-%m-%d %H:%M')}
+                        ${authorinfo(blog_comment.author)} --
+                        ${pretty_dateinfo and pretty_dateinfo(blog_comment.time) or format_datetime(blog_comment.time)}
                       </div>
                       <div class="comment_body">${wiki_to_html(context, blog_comment.comment)}</div>
                     </fieldset>
@@ -129,11 +129,7 @@
                     <input id="author" type="text"
                         name="author" size="30"
                         value="${(defined('blog_comment') and blog_comment.author)
-                                 or (req.authname == 'anonymous' and
-                                         (req.session.get('email')
-                                             or req.session.get('name')
-                                             or req.authname))
-                                 or req.authname}" />
+                                 or get_reporter_id(req)}" />
                 </div>
                 <div class="buttons">
                   <input type="submit" name="previewcomment" value="Preview comment" />